(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@babel/runtime/helpers/classCallCheck'), require('@babel/runtime/helpers/createClass'), require('lodash/isObject'), require('conflux-web-providers'), require('conflux-web-core-method'), require('conflux-web-utils')) :
    typeof define === 'function' && define.amd ? define(['exports', '@babel/runtime/helpers/classCallCheck', '@babel/runtime/helpers/createClass', 'lodash/isObject', 'conflux-web-providers', 'conflux-web-core-method', 'conflux-web-utils'], factory) :
    (global = global || self, factory(global.ConfluxWebCore = {}, global._classCallCheck, global._createClass, global.isObject, global.confluxWebProviders, global.confluxWebCoreMethod, global.confluxWebUtils));
}(this, (function (exports, _classCallCheck, _createClass, isObject, confluxWebProviders, confluxWebCoreMethod, confluxWebUtils) { 'use strict';

    _classCallCheck = _classCallCheck && Object.prototype.hasOwnProperty.call(_classCallCheck, 'default') ? _classCallCheck['default'] : _classCallCheck;
    _createClass = _createClass && Object.prototype.hasOwnProperty.call(_createClass, 'default') ? _createClass['default'] : _createClass;
    isObject = isObject && Object.prototype.hasOwnProperty.call(isObject, 'default') ? isObject['default'] : isObject;

    var AbstractConfluxWebModule = function () {
      function AbstractConfluxWebModule(provider) {
        var _this = this;
        var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        var methodFactory = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
        var nodeNet = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
        _classCallCheck(this, AbstractConfluxWebModule);
        this.providerResolver = new confluxWebProviders.ProviderResolver();
        this.givenProvider = confluxWebProviders.ProviderDetector.detect();
        this._currentProvider = this.providerResolver.resolve(provider, nodeNet);
        this._defaultAccount = options.defaultAccount ? confluxWebUtils.toChecksumAddress(options.defaultAccount) : undefined;
        this._defaultEpoch = options.defaultEpoch || 'latest_state';
        this._transactionBlockTimeout = options.transactionBlockTimeout || 50;
        this._transactionConfirmationBlocks = options.transactionConfirmationBlocks || 24;
        this._transactionPollingTimeout = options.transactionPollingTimeout || 750;
        this._defaultGasPrice = options.defaultGasPrice;
        this._defaultGas = options.defaultGas;
        this.BatchRequest = function () {
          return new confluxWebProviders.BatchRequest(_this);
        };
        if (methodFactory) {
          return new confluxWebCoreMethod.MethodProxy(this, methodFactory);
        }
      }
      _createClass(AbstractConfluxWebModule, [{
        key: "setProvider",
        value: function setProvider(provider, net) {
          if (!this.isSameProvider(provider)) {
            var resolvedProvider = this.providerResolver.resolve(provider, net);
            this.clearSubscriptions();
            this._currentProvider = resolvedProvider;
            return true;
          }
          return false;
        }
      }, {
        key: "isSameProvider",
        value: function isSameProvider(provider) {
          if (isObject(provider)) {
            if (this.currentProvider.constructor.name === provider.constructor.name) {
              return this.currentProvider.host === provider.host;
            }
            return false;
          }
          return this.currentProvider.host === provider;
        }
      }, {
        key: "clearSubscriptions",
        value: function clearSubscriptions(unsubscribeMethod) {
          if (typeof this.currentProvider.clearSubscriptions !== 'undefined' && this.currentProvider.subscriptions.length > 0) {
            return this.currentProvider.clearSubscriptions(unsubscribeMethod);
          }
          return Promise.resolve(true);
        }
      }, {
        key: "defaultEpoch",
        get: function get() {
          return this._defaultEpoch;
        }
        ,
        set: function set(value) {
          this._defaultEpoch = value;
        }
      }, {
        key: "transactionBlockTimeout",
        get: function get() {
          return this._transactionBlockTimeout;
        }
        ,
        set: function set(value) {
          this._transactionBlockTimeout = value;
        }
      }, {
        key: "transactionConfirmationBlocks",
        get: function get() {
          return this._transactionConfirmationBlocks;
        }
        ,
        set: function set(value) {
          this._transactionConfirmationBlocks = value;
        }
      }, {
        key: "transactionPollingTimeout",
        get: function get() {
          return this._transactionPollingTimeout;
        }
        ,
        set: function set(value) {
          this._transactionPollingTimeout = value;
        }
      }, {
        key: "defaultGasPrice",
        get: function get() {
          return this._defaultGasPrice;
        }
        ,
        set: function set(value) {
          this._defaultGasPrice = value;
        }
      }, {
        key: "defaultGas",
        get: function get() {
          return this._defaultGas;
        }
        ,
        set: function set(value) {
          this._defaultGas = value;
        }
      }, {
        key: "defaultAccount",
        get: function get() {
          return this._defaultAccount;
        }
        ,
        set: function set(value) {
          this._defaultAccount = confluxWebUtils.toChecksumAddress(value);
        }
      }, {
        key: "currentProvider",
        get: function get() {
          return this._currentProvider;
        }
        ,
        set: function set(value) {
          throw new Error('The property currentProvider is read-only!');
        }
      }], [{
        key: "providers",
        get: function get() {
          return {
            HttpProvider: confluxWebProviders.HttpProvider,
            WebsocketProvider: confluxWebProviders.WebsocketProvider,
            IpcProvider: confluxWebProviders.IpcProvider
          };
        }
      }]);
      return AbstractConfluxWebModule;
    }();

    exports.AbstractConfluxWebModule = AbstractConfluxWebModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
